<?php
// (C) 2005 Matteo Lucarelli
// (C) 2000-2003 Marco Pratesi <marco@pgmarket.net>
// (C) 2000 Ying Zhang (ying@zippydesign.com)
// (C) 2000-2001 Fabio Molinari <fabio.m@mclink.it>

include ("../config.inc.php");
include ("../common.inc.php");
require_login();
require_priv("admin");
include ($CFG["libdir"] . $CFG["dbms"] . "_for_admin.inc.php");

$DOC_TITLE = "Categories_Management";
include ("../header.php");

if ($_SERVER["REQUEST_METHOD"] == "GET") {
	$id = nvl($_GET["id"], 1);
	$mode = nvl($_GET["mode"], "");
}
if ($_SERVER["REQUEST_METHOD"] == "POST") {
	$id = nvl($_POST["id"], 1);
	$mode = nvl($_POST["mode"], "");
}

switch (nvl($mode)) {
	case "add":
		print_add_category_form($id);
		break;

	case "edit":
		print_edit_category_form($id);
		break;

	case "del":
		if ($id != 1) {
			delete_category($id);
			if ($CFG["layersmenu_cached"]) {
				refresh_cache();
			}
		}else list_categories();
		break;

	case "insert":
		$errors = array();
		$errormsg = "";
		include ($CFG["libdir"] . "pgm_validate.inc.php");
		validate_category_name($_POST["name"], $errors, $errormsg);
		validate_special_level($_POST["special_level"], $errors, $errormsg);
		validate_category_description($_POST["description"], $errors, $errormsg);
		if ($errormsg == "") {
			insert_category($_POST);
			if ($CFG["layersmenu_cached"]) {
				refresh_cache();
			}
		} else {
			// set default values for the reset of the fields
			$frm = $_POST;
			$frm["parent"] = array($_POST["parent"]);
			$frm["newmode"] = "insert";
			$frm["submit_caption"] = "Add_Subcategory";
			// build the categories listbox options, preselect the selected item
			build_category_tree($category_options, $frm["parent"]);
			include ($CFG["dirroot"] . "form_header.php");
			load_category_form_template($frm, $category_options, $errors);
		}
		break;

	case "update":
		$errors = array();
		$errormsg = "";
		include ($CFG["libdir"] . "pgm_validate.inc.php");
		validate_category_name($_POST["name"], $errors, $errormsg);
		validate_special_level($_POST["special_level"], $errors, $errormsg);
		validate_category_description($_POST["description"], $errors, $errormsg);
		if ($id == $_POST["parent"]) {
			$errors["category_parent"] = true;
			include ($CFG["globalerror"]);
			$errormsg .= "<li>" . $category_cannot_be_parent_of_itself;
		}
		if ($errormsg == "") {
			update_category($_POST);
			if ($CFG["layersmenu_cached"]) {
				refresh_cache();
			}
		} else {
			// set default values for the reset of the fields
			$frm = $_POST;
			$frm["parent"] = array($_POST["parent"]);
			$frm["newmode"] = "update";
			$frm["submit_caption"] = "Save_Changes";
			// build the categories listbox options, preselect the selected item
			build_category_tree($category_options, $frm["parent"]);
			include ($CFG["dirroot"] . "form_header.php");
			load_category_form_template($frm, $category_options, $errors);
		}
		break;
	default:
		$PGM_SESSION["goback"]["request_uri"] = stripsid(me() . "?" . $_SERVER["QUERY_STRING"]);
		list_categories();
		break;
}

include ("../footer.php");

pgm_session_close($PGM_SESSION, $session_name);

/* *******************************************************************
 * FUNCTIONS
 ****************************************************************** */

function load_category_form_template($frm, $category_options, $errors) {
	global $CFG;

	$t = new Template();
	$t->set_file("page", "templates/category_form.ihtml");
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");
	$t->set_var("star", return_star());
	$t->set_var(array(
		"frm_newmode"		=> $frm["newmode"],
		"id"			=> nvl($frm["id"], ""),
		"category_options"	=> $category_options,
		"errors_category_parent" => errmsg2(nvl($errors["category_parent"], "")),
		"frm_name"		=> ov(nvl($frm["name"], "")),
		"errors_name"		=> errmsg(nvl($errors["category_name"], "")),
		"frm_special_level"	=> nvl($frm["special_level"], ""),
		"errors_special_level"	=> errmsg(nvl($errors["special_level"], "")),
		"frm_description"	=> ov(nvl($frm["description"], "")),
		"errors_description"	=> errmsg(nvl($errors["category_description"], "")),
		"frm_submit_caption"	=> $t->get_var($frm["submit_caption"]),
		"frm_old_imagetype"	=> nvl($frm["old_imagetype"], ""),
		"frm_old_imagewidth"	=> nvl($frm["old_imagewidth"], ""),
		"frm_old_imageheight"	=> nvl($frm["old_imageheight"], ""),
		"frm_old_thumbtype"	=> nvl($frm["old_thumbtype"], ""),
		"frm_old_thumbwidth"	=> nvl($frm["old_thumbwidth"], ""),
		"frm_old_thumbheight"	=> nvl($frm["old_thumbheight"], ""),
		"max_file_size_images"	=> $CFG["max_file_size_images"]
	));
	
	$t->set_block("page", "is_top", "is_top_blck");
	$t->set_var("is_top_blck", "");
	if ($frm["id"] != "1") $t->parse("is_top_blck", "is_top", true);
	
	$t->set_block("page", "delete_current_image", "delete_current_image_blck");
	$t->set_var("delete_current_image_blck", "");
	if ($frm["newmode"] == "update" &&
		(($CFG["images_on_file_system"] && file_exists($CFG["productsdir"] . "cat" . nvl($frm["id"], "") . "." . $frm["old_imagetype"]))
		||(!$CFG["images_on_file_system"] && $frm["old_imagetype"] != ""))) {
		$t->set_var("frm_delete_image_checked", nvl($frm["delete_image"], "") ? "checked" : "");
		$t->parse("delete_current_image_blck", "delete_current_image", true);
	}
	$t->set_block("page", "create_image_thumb", "create_image_thumb_blck");
	$t->set_var("create_image_thumb_blck", "");
	if ($CFG["use_imagemagick"] || $CFG["use_libgd"] || $CFG["use_netpbm"]) {
		$t->set_var("frm_create_thumb_checked", nvl($frm["create_thumb"], "") ? "checked" : "");
		$t->parse("create_image_thumb_blck", "create_image_thumb", true);
	}
	$t->set_block("page", "delete_current_thumb", "delete_current_thumb_blck");
	$t->set_var("delete_current_thumb_blck", "");
	if ($frm["newmode"] == "update"	&&
		(($CFG["images_on_file_system"] && 
		file_exists($CFG["productsdir"] . "cat" . nvl($frm["id"], "") . ".thumb." . $frm["old_thumbtype"]))||
		(!$CFG["images_on_file_system"] && $frm["old_thumbtype"] != ""))){
		$t->set_var("frm_delete_thumb_checked", nvl($frm["delete_thumb"], "") ? "checked" : "");
		$t->parse("delete_current_thumb_blck", "delete_current_thumb", true);
	}
	
	$t->pparse("out", "page");
}

/**
* Prepares an empty form to add a new category
* @param integer $id the category id to set as preselected parent
*   for the new category
* @return void
*/
function print_add_category_form($id) {
	// set default values for the reset of the fields
	$frm["parent"] = array($id);
	$frm["newmode"] = "insert";
	$frm["name"] = "";
	$frm["special_level"] = "";
	$frm["description"] = "";
	$frm["create_thumb"] = 1;
	$frm["submit_caption"] = "Add_Subcategory";

	// build the categories listbox options, preselect the selected item
	build_category_tree($category_options, $frm["parent"]);
	$errors = array();

	load_category_form_template($frm, $category_options, $errors);
}

function print_edit_category_form($id) {
	$qid = new PGM_Sql("
		SELECT name, special_level, description, parent_id, 
		imagetype ,imagewidth, imageheight, thumbtype, thumbwidth, thumbheight
		FROM categories
		WHERE id = '$id'
	");
	$qid->next_record();
	$frm["id"] = $id;
	$frm["name"] = $qid->f("name");
	$frm["special_level"] = $qid->f("special_level");
	$frm["description"] = $qid->f("description");
	$frm["imagetype"] = $qid->f("imagetype");
	$frm["imagewidth"] = $qid->f("imagewidth");
	$frm["imageheight"] = $qid->f("imageheight");
	$frm["thumbtype"] = $qid->f("thumbtype");
	$frm["thumbwidth"] = $qid->f("thumbwidth");
	$frm["thumbheight"] = $qid->f("thumbheight");
	$frm["old_imagetype"] = $frm["imagetype"];
	$frm["old_imagewidth"] = $frm["imagewidth"];
	$frm["old_imageheight"] = $frm["imageheight"];
	$frm["old_thumbtype"] = $frm["thumbtype"];
	$frm["old_thumbwidth"] = $frm["thumbwidth"];
	$frm["old_thumbheight"] = $frm["thumbheight"];
	$frm["create_thumb"] = 1;
	$frm["parent_id"] = $qid->f("parent_id");
	$frm["parent"] = array($frm["parent_id"]);
	$frm["newmode"] = "update";
	$frm["submit_caption"] = "Save_Changes";

	// build the categories listbox options, preselect the selected item
	build_category_tree($category_options, $frm["parent"]);
	$errors = array();

	load_category_form_template($frm, $category_options, $errors);
}

/**
* Deletes a category
*
* All products and categories under the category to be deleted
* are moved to the immediate parent
*
* @param integer $id the id of the category to be deleted
* @return void
*/
function delete_category($id) {
	
	global $PGM_SESSION;
	global $CFG;

	$qid = new PGM_Sql();
	$qid->begin();

	// find the parent of this category
	$qid->query("
		SELECT cat.name, cat.parent_id, cat.imagetype, cat.thumbtype, parent.name AS parent
		FROM categories cat, categories parent
		WHERE parent.id = cat.parent_id AND cat.id = '$id'
	");
	$qid->next_record();
	$cat = array();
	$cat["name"] = $qid->f("name");
	$cat["parent_id"] = $qid->f("parent_id");
	$cat["parent"] = $qid->f("parent");
	$cat["thumbtype"] = $qid->f("thumbtype");
	$cat["imagetype"] = $qid->f("imagetype");

	// delete products in this category that also belong
	// to the parent category, to avoid duplicates forbidden
	// by the primary key constraint
/* Nested queries aren't still supported by MySQL :(
 *	$qid->query("
 *		DELETE FROM products_categories WHERE ( product_id,category_id ) IN (
 *			SELECT * FROM products_categories pc WHERE category_id = '$id' AND
 *			EXISTS (
 *				SELECT * FROM products_categories
 *				WHERE product_id = pc.product_id
 *					AND category_id = '$cat->parent_id'
 *			)
 *		)
 *	");
 * a workaround in the following */
	$qid->query("
		SELECT pc1.product_id
		FROM products_categories pc1 , products_categories pc2
		WHERE
			pc1.product_id = pc2.product_id
			AND pc1.category_id = '" . $cat["parent_id"] ."'
			AND pc2.category_id = '$id'
	");
	if (($numr = $qid->num_rows()) > 0) {
		$toberemoved = "";
		for ($i=0; $i<$numr-1; $i++) {
			$qid->next_record();
			$toberemoved .= "'" . $qid->f("product_id") . "', ";
		}
		$qid->next_record();
		$toberemoved .= "'" . $qid->f("product_id") . "'";
		$qid->query("
			DELETE FROM products_categories
			WHERE category_id = '$id' AND product_id IN ($toberemoved)
		");
	}

	// re-assign all the products in this category to the parent category
	$qid->query("
		UPDATE products_categories
		SET category_id = '" . $cat["parent_id"] . "'
		WHERE category_id = '$id'
	");

	// re-assign all sub categories of this category to the parent category
	$qid->query("
		UPDATE categories
		SET parent_id = '" . $cat["parent_id"] . "'
		WHERE parent_id = '$id'
	");

	// delete this category from the categories table
	$qid->query("DELETE FROM categories WHERE id = '$id'");
	// delete this category from the categories_i18n table
	$qid->query("DELETE FROM categories_i18n WHERE category_id = '$id'");

	$qid->commit();
	
	if ($CFG["images_on_file_system"]) {
		// Remove the category image
		if ($cat["imagetype"] != "") {
			$upload_name = $CFG["productsdir"] . "cat" . $id . "." . $cat["imagetype"];
/*
			if ($CFG["unix"]) {
*/
				// Note: This function may not work on Windows systems.
				unlink ($upload_name);
/*
			} else {
				// FIXME: in this case we should check safe_mode and open_basedir to check
				// if it is possible to remove the product image and, if it is not possible,
				// issue an error message!!!
				system ($CFG["rmf"] . " " . $upload_name, $result);
			}
*/
		}
		// Remove the category thumb
		if ($cat["thumbtype"] != "") {
			$upload_thumb_name = $CFG["productsdir"] . "cat" . $id . ".thumb." . $cat["thumbtype"];
/*
			if ($CFG["unix"]) {
*/
				// Note: This function may not work on Windows systems.
				unlink ($upload_thumb_name);
/*
			} else {
				system ($CFG["rmf"] . " " . $upload_thumb_name, $result);
			}
*/
		}
	}
	list_categories();
}

function insert_category($frm) {
	global $PGM_SESSION;
	global $CFG;

	while (list($key, $val) = each($frm)) {
		if (is_string($val)) $frm[$key] = addslashes($val);
	}
	
	$qid = new PGM_Sql();
	$qid->lock("categories");
	$qid->query("
		INSERT INTO categories (
			 parent_id
			,name
			,special_level
			,description
		)
		VALUES (
			 '" . $frm["parent"] . "'
			,'" . $frm["name"] . "'
			,'" . (int) $frm["special_level"] . "'
			,'" . $frm["description"] . "'
		)
	");
	$qid->query("SELECT id FROM categories ORDER BY id DESC");
	$qid->next_record();
	$inserted_category_id = $qid->f("id");
	$qid->unlock();

	$frm["id"] = $inserted_category_id;
	update_images($frm);
	
	list_categories();
}

function update_category($frm) {
	global $PGM_SESSION;
	global $CFG;

	while (list($key, $val) = each($frm)) {
		if (is_string($val)) $frm[$key] = addslashes($val);
	}
	
	if ($frm["id"]=="1"){
		$qid = new PGM_Sql("
			UPDATE categories SET
				 parent_id = '1'
				,name = '" . $frm["name"] . "'
				,special_level = '-1'
				,description = '" . $frm["description"] . "'
			WHERE id = '" . $frm["id"] . "'
		");
	}else{
		$qid = new PGM_Sql("
			UPDATE categories SET
				 parent_id = '" . $frm["parent"] . "'
				,name = '" . $frm["name"] . "'
				,special_level = '" . (int) $frm["special_level"] . "'
				,description = '" . $frm["description"] . "'
			WHERE id = '" . $frm["id"] . "'
		");
	}
	update_images($frm);

	list_categories();
}

function list_categories() {
	global $_GET;
	global $PGM_SESSION;
	global $CFG, $ME;

	if (!isset($_GET["page_number"])) {
		$page_number = 1;
	} else {
		$page_number = max(1, abs(intval($_GET["page_number"])));
	}

	$qid = new PGM_Sql("SELECT COUNT(id) AS cnt FROM categories");
	$qid->next_record();
	include ($CFG["libdir"] . "pgm_pager.inc.php");
	$result = pgm_pager($ME, $qid->f("cnt"), $CFG["categories_per_page"], $page_number);
	$limit = $result["last"] - $result["first"] + 1;
	$limit_clause = prepare_limit_clause($limit, $result["first"]);
	$qid->query("
		SELECT cat.id, cat.name, cat.special_level, cat.description, cat.thumbtype, cat.thumbheight, cat.thumbwidth, parent.name AS parent
		FROM categories cat, categories parent
		WHERE parent.id = cat.parent_id ORDER BY cat.name
		$limit_clause
	");

	$t = new Template();
	$t->set_file("page", "templates/category_list.ihtml");
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");
	$t->set_block("page", "pages_links_bottom", "pages_links_bottom_blck");
	$t->set_var("pages_links_bottom_blck", "");
	if ($result["num_pages"] > 1) {
		$t->set_var("pages_links", $result["html"]);
		$t->parse("pages_links_bottom_blck", "pages_links_bottom", true);
	}
	$t->set_block("page", "category_row", "category_rows");
	$t->set_var("category_rows", "");
		$t->set_block("category_row", "admincatthumb", "admincatthumb_blck");
		$t->set_block("category_row", "admincatnothumb", "admincatnothumb_blck");
	while ($qid->next_record()) {
		$t->set_var("admincatthumb_blck", "");
		$t->set_var("admincatnothumb_blck", "");
		$t->set_var(array(
			"id"		=> $qid->f("id"),
			"parent"	=> ov($qid->f("parent")),
			"name"		=> ov($qid->f("name")),
			"special_level"	=> $qid->f("special_level"),
			"description"	=> ovwbr($qid->f("description"))
		));
		if ($CFG["images_on_file_system"] && file_exists($CFG["productsdir"] . "cat" . $qid->f("id") . ".thumb." . $qid->f("thumbtype"))) {
			$t->set_var(array(
				"thumbsrc"	=> "getimage.php?image=" . "cat" . $qid->f("id") . ".thumb." . $qid->f("thumbtype") . "&amp;type=" . $qid->f("thumbtype"),
				"thumbwidth"	=> $qid->f("thumbwidth"),
				"thumbheight"	=> $qid->f("thumbheight")
			));
			$t->parse("admincatthumb_blck", "admincatthumb", true);
		} else if (!$CFG["images_on_file_system"] && $qid->f("thumbtype") != "") {
			$t->set_var(array(
				"thumbsrc"	=> "dbgetimage.php?type=thumb&from=categories&id=" . $qid->f("id"),
				"thumbwidth"	=> $qid->f("thumbwidth"),
				"thumbheight"	=> $qid->f("thumbheight")
			));
			$t->parse("admincatthumb_blck", "admincatthumb", true);
		} else {
			$t->parse("admincatnothumb_blck", "admincatnothumb", true);
		}
		$t->parse("category_rows", "category_row", true);
	}
	$t->pparse("out", "page");
}

/**
* Updates the image and the thumb for a given product
* @param array $frm the array containing values to be used for updating
* @return void
*/
function update_images($frm) {
	global $_FILES;
	global $PGM_SESSION;
	global $CFG;
	include ($CFG["globalerror"]);

/* does PHP 4.0.4pl1 have a bug causing $HTTP_POST_FILES['image']['type'] == "" ? 
echo ";".$HTTP_POST_FILES['image']['name'].";";
echo     $HTTP_POST_FILES['image']['tmp_name'].";";
echo     $HTTP_POST_FILES['image']['size'].";";
echo     $HTTP_POST_FILES['image']['type'].";";
echo "<br><br>";
reset($HTTP_POST_FILES['image']);
while (list($key, $value) = each($HTTP_POST_FILES['image'])) {
	echo "\$HTTP_POST_FILES['image'][$key] => ;$value;";
	echo "<br>";
}*/

	$imagesize = array();
	$imagesize[0] = nvl($frm["old_imagewidth"], 0);
	$imagesize[1] = nvl($frm["old_imageheight"], 0);
	$imagetype = nvl($frm["old_imagetype"], "");
	$thumbsize = array();
	$thumbsize[0] = nvl($frm["old_thumbwidth"], 0);
	$thumbsize[1] = nvl($frm["old_thumbheight"], 0);
	$thumbtype = nvl($frm["old_thumbtype"], "");

	$thumb_has_to_be_created = nvl($frm["create_thumb"], 0); 
	$thumb_has_been_uploaded = !(nvl($_FILES["thumb"]["tmp_name"], "") == "none") && !(nvl($_FILES["thumb"]["tmp_name"], "") == "");

	if (nvl($frm["delete_image"], 0)) {
		if ($CFG["images_on_file_system"]) {
			$upload_name = $CFG["productsdir"] . "cat" . $frm["id"] . "." . $imagetype;
			if (file_exists($upload_name)) {
/*
				if ($CFG["unix"]) {
*/
					// Note: This function may not work on Windows systems.
					unlink ($upload_name);
/*
				} else {
					system ($CFG["rmf"] . " " . $upload_name, $result);
				}
*/
			}
		} else {
			$qid = new PGM_Sql("
				UPDATE categories SET imagedata = ''
				WHERE id = '" . $frm["id"] . "'
			");
		}
		$imagesize[0] = 0;
		$imagesize[1] = 0;
		$imagetype = "";
	}
	if (nvl($frm["delete_thumb"], 0)) {
		if ($CFG["images_on_file_system"]) {
			$upload_thumb_name = $CFG["productsdir"] . "cat" . $frm["id"] . ".thumb." . $thumbtype;
			if (file_exists($upload_thumb_name)) {
/*
				if ($CFG["unix"]) {
*/
					// Note: This function may not work on Windows systems.
					unlink ($upload_thumb_name);
/*
				} else {
					system ($CFG["rmf"] . " " . $upload_thumb_name, $result);
				}
*/
			}
		} else {
			$qid = new PGM_Sql("
				UPDATE categories SET thumbdata = ''
				WHERE id = '" . $frm["id"] . "'
			");
		}
		$thumbsize[0] = 0;
		$thumbsize[1] = 0;
		$thumbtype = "";
	}

	if (nvl($_FILES["image"]["tmp_name"], "") == "none" || nvl($_FILES["image"]["tmp_name"], "") == "") {	// "" --> Opera 5
		//message($no_product_image_chosen);
	} else {
		$upload_name = $CFG["productsdir"] . "cat" . $frm["id"];
		if (!move_uploaded_file($_FILES["image"]["tmp_name"], $upload_name)) {
			error($image_upload_failed);
		} else {
			$newimagesize = getimagesize ($upload_name);
			switch ($newimagesize[2]) {
				case 1:
					$newimagetype = "gif";
					break;
				case 2:
					$newimagetype = "jpg";
					break;
				case 3:
					$newimagetype = "png";
					break;
				default:
					$newimagetype = "";
					error($unsupported_image_type);
			}
			if ($newimagetype != "") {
				$foobar = $upload_name;
				$upload_name .= "." . $newimagetype;
				rename ($foobar, $upload_name);
				$old_image_name = $CFG["productsdir"] . "cat" . $frm["id"] . "." . $imagetype;
				$imagesize = $newimagesize;
				$imagetype = $newimagetype;
				if ($CFG["unix"]) {
					// Note: This function is not implemented on Windows platforms.
					chmod ($upload_name, 0644);
				}
				if ($old_image_name != $upload_name && file_exists($old_image_name)) {
/*
					if ($CFG["unix"]) {
*/
						// Note: This function may not work on Windows systems.
						unlink ($old_image_name);
/*
					} else {
						system ($CFG["rmf"] . " " . $old_image_name, $result);
					}
*/
				}
				if ($CFG["create_thumbs"] && $thumb_has_to_be_created && !$thumb_has_been_uploaded) {
					$old_thumb_name = $CFG["productsdir"] . "cat" . $frm["id"] . ".thumb." . $thumbtype;
					$upload_thumb_name = $CFG["productsdir"] . "cat" . $frm["id"] . ".thumb.jpg";
					if (!create_thumb($upload_name, $imagesize, $upload_thumb_name, $newthumbsize)) {
						error($could_not_create_thumb);
					} else {
						$thumbsize = $newthumbsize;
						$thumbtype = "jpg";
						if ($CFG["unix"]) {
							// Note: This function is not implemented on Windows platforms.
							chmod ($upload_thumb_name, 0644);
						}
						if ($old_thumb_name != $upload_thumb_name && file_exists($old_thumb_name)) {
/*
							if ($CFG["unix"]) {
*/
								// Note: This function may not work on Windows systems.
								unlink ($old_thumb_name);
/*
							} else {
								system ($CFG["rmf"] . " " . $old_thumb_name, $result);
							}
*/
						}
					}
				}
			} else {
/*
				if ($CFG["unix"]) {
*/
					// Note: This function may not work on Windows systems.
					unlink ($upload_name);
/*
				} else {
					system ($CFG["rmf"] . " " . $upload_name, $result);
				}
*/
			}
		}
	}

	if ($thumb_has_been_uploaded) {
		$upload_thumb_name = $CFG["productsdir"] . "cat" . $frm["id"] . ".thumb";
		if (!move_uploaded_file($_FILES["thumb"]["tmp_name"], $upload_thumb_name)) {
			error($thumb_upload_failed);
		} else {
			$newthumbsize = getimagesize ($upload_thumb_name);
			switch ($newthumbsize[2]) {
				case 1:
					$newthumbtype = "gif";
					break;
				case 2:
					$newthumbtype = "jpg";
					break;
				case 3:
					$newthumbtype = "png";
					break;
				default:
					$newthumbtype = "";
					error($unsupported_thumb_type);
					break;
			}
			if ($newthumbtype != "") {
				$foobar = $upload_thumb_name;
				$upload_thumb_name .= "." . $newthumbtype;
				rename($foobar, $upload_thumb_name);
				$old_thumb_name = $CFG["productsdir"] . "cat" . $frm["id"] . ".thumb." . $thumbtype;
				$thumbsize = $newthumbsize;
				$thumbtype = $newthumbtype;
				if ($CFG["unix"]) {
					// Note: This function is not implemented on Windows platforms.
					chmod ($upload_thumb_name, 0644);
				}
				if ($old_thumb_name != $upload_thumb_name && file_exists($old_thumb_name)) {
/*
					if ($CFG["unix"]) {
*/
						// Note: This function may not work on Windows systems.
						unlink ($old_thumb_name);
/*
					} else {
						system ($CFG["rmf"] . " " . $old_thumb_name, $result);
					}
*/
				}
			} else {
/*
				if ($CFG["unix"]) {
*/
					// Note: This function may not work on Windows systems.
					unlink ($upload_thumb_name);
/*
				} else {
					system ($CFG["rmf"] . " " . $upload_thumb_name, $result);
				}
*/
			}
		}
	}

	if (!$CFG["images_on_file_system"]) {
		$imagedata = "";
		if (isset($upload_name) && file_exists($upload_name)) {
			$fd = fopen ($upload_name, "rb");
			$contents = fread ($fd, filesize ($upload_name));
			fclose ($fd);
			$imagedata = base64_encode($contents);
			$qid = new PGM_Sql("
				UPDATE categories SET imagedata = '$imagedata'
				WHERE id = '" . $frm["id"] . "'
			");
/*
			if ($CFG["unix"]) {
*/
				// Note: This function may not work on Windows systems.
				unlink ($upload_name);
/*
			} else {
				system ($CFG["rmf"] . " " . $upload_name, $result);
			}
*/
		}
		$thumbdata = "";
		if (isset($upload_thumb_name) && file_exists($upload_thumb_name)) {
			$fd = fopen ($upload_thumb_name, "rb");
			$contents = fread ($fd, filesize ($upload_thumb_name));
			fclose ($fd);
			$thumbdata = base64_encode($contents);
			$qid = new PGM_Sql("
				UPDATE categories SET thumbdata = '$thumbdata'
				WHERE id = '" . $frm["id"] . "'
			");
/*
			if ($CFG["unix"]) {
*/
				// Note: This function may not work on Windows systems.
				unlink ($upload_thumb_name);
/*
			} else {
				system ($CFG["rmf"] . " " . $upload_thumb_name, $result);
			}
*/
		}
	}

	$qid = new PGM_Sql("
		UPDATE categories SET
			 imagetype = '$imagetype'
			,imagewidth = '$imagesize[0]'
			,imageheight = '$imagesize[1]'
			,thumbtype = '$thumbtype'
			,thumbwidth = '$thumbsize[0]'
			,thumbheight = '$thumbsize[1]'
		WHERE id = '" . $frm["id"] . "'
	");
}

?>
