<?php
// (C)2005 Matteo Lucarelli

include ("../config.inc.php");
include ("../common.inc.php");
require_login();
require_priv("admin");

$DOC_TITLE = "Download_Management";
include ("../header.php");

if ($_SERVER["REQUEST_METHOD"] == "GET") {
	$id = nvl($_GET["id"], 1);
	$mode = nvl($_GET["mode"], "");
}
if ($_SERVER["REQUEST_METHOD"] == "POST") {
	$id = nvl($_POST["id"], 0);
	$mode = nvl($_POST["mode"], "");
}

switch (nvl($mode)) {
	case "add":
		print_add_download_form();
		break;

	case "edit":
		print_edit_download_form($id);
		break;

	case "del":
		delete_download($id);
		break;
		
	case "insert":
		$errors = array();
		$errormsg = "";
		
		include ($CFG["libdir"] . "pgm_validate.inc.php");
		validate_name($_POST["name"], $errors, $errormsg);
		
		if ($errormsg == "") {
			insert_download($_POST);
		} else {
			// set default values for the reset of the fields
			$frm = $_POST;
			$frm["newmode"] = "insert";
			$frm["submit_caption"] = "Add_Download";
			include ($CFG["dirroot"] . "form_header.php");
			load_download_form_template($frm, $errors, 1);
		}
		break;
		
	case "update":
		update_download($_POST);
		break;
	default:
		list_download();
		break;
}

include ("../footer.php");

pgm_session_close($PGM_SESSION, $session_name);

/* *******************************************************************
 * FUNCTIONS
 ****************************************************************** */

function load_download_form_template($frm, $errors, $add) {
	global $CFG;

	$t = new Template();
	$t->set_file("page", "templates/download_form.ihtml");
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");
	$t->set_var("star", return_star());
	$t->set_var(array(
		"frm_newmode"		=> $frm["newmode"],
		"id"			=> nvl($frm["id"]),
		"frm_name"		=> ov($frm["name"]),
		"errors_name"		=> errmsg(nvl($errors["name"], "")),
		"frm_description"	=> ov($frm["description"]),
		"errors_file"		=> errmsg(nvl($errors["file"], "")),
		"frm_submit_caption"	=> $t->get_var($frm["submit_caption"])
	));
	
	$t->set_block("page", "add_file1", "add_file1_blck");
	$t->set_var("add_file1_blck", "");
	$t->set_block("page", "add_file2", "add_file2_blck");
	$t->set_var("add_file2_blck", "");
	$t->set_block("page", "edit_file", "edit_file_blck");
	$t->set_var("edit_file_blck", "");
	
	if ($add){ 
		$t->parse("add_file1_blck", "add_file1", true);
		$t->parse("add_file2_blck", "add_file2", true);
	}else $t->parse("edit_file_blck", "edit_file", true);
	
	$t->pparse("out", "page");
}

function print_add_download_form() {

	// set default values for the reset of the fields
	$frm["newmode"] = "insert";
	$frm["name"] = "";
	$frm["description"] = "";
	$frm["submit_caption"] = "Add_Download";
	$errors = array();

	load_download_form_template($frm, $errors, 1);
}

function insert_download($frm) {
	global $_FILES;
	global $PGM_SESSION;
	global $CFG;

	while (list($key, $val) = each($frm)) {
		if (is_string($val)) $frm[$key] = addslashes($val);
	}
	
	$ext = strrchr( $_FILES["userfile"]["name"], '.' );
	
	$upload_file_name = $CFG["downloaddir"] . $frm["name"] . $ext;
	
	if (!move_uploaded_file($_FILES["userfile"]["tmp_name"], $upload_file_name)) {
		include ($CFG["globalerror"]);
		$errors = array();
		$errors["file"] = true;
		$errormsg = "<li>" . $import_file_upload_failed;
		$frm = $_POST;
		$frm["newmode"] = "insert";
		$frm["submit_caption"] = "Add_Download";
		include ($CFG["dirroot"] . "form_header.php");
		load_download_form_template($frm, $errors, 1);
	}else{
		chmod ($upload_file_name, 0644);
	
		$qid = new PGM_Sql();
		$qid->lock("download");
		$qid->query("
			INSERT INTO download (
				 filetype
				,name
				,description
			)
			VALUES (
				 '" . $ext . "'
				,'" . $frm["name"] . "'
				,'" . $frm["description"] . "'
			)
		");
		$qid->unlock();
		list_download();
	}

}

function delete_download($id) {
	global $PGM_SESSION;
	global $CFG;
	
	$qid = new PGM_Sql();
	$qid->query("SELECT name, filetype FROM download WHERE id = '$id'");
	$qid->next_record();
	
	$filename = $CFG["downloaddir"] . $qid->f("name") . $qid->f("filetype");
	
/*
	if ($CFG["unix"]) {
*/
		// Note: This function may not work on Windows systems.
		unlink ($filename);
/*
	} else {
		system ($CFG["rmf"] . " " . $old_image_name, $result);
	}
*/


	$qid->begin();
	$qid->query("DELETE FROM download WHERE id = '$id'");
	$qid->commit();
	
	list_download();
}


function print_edit_download_form($id) 
{
	$qid = new PGM_Sql("SELECT name, description FROM download WHERE id = '$id'");
	$qid->next_record();
	$frm["id"] = $id;
	$frm["name"] = $qid->f("name");
	$frm["description"] = $qid->f("description");

	$frm["newmode"] = "update";
	$frm["submit_caption"] = "Save_Changes";
	$errors = array();

	load_download_form_template($frm, $errors, 0);
}

function update_download($frm) 
{
	global $PGM_SESSION;
	global $CFG;

	while (list($key, $val) = each($frm)) {
		if (is_string($val)) $frm[$key] = addslashes($val);
	}

	$qid = new PGM_Sql("
		UPDATE download SET description = '" . $frm["description"] . "'
		WHERE id = '" . $frm["id"] . "'
	");
	list_download();
}

function list_download() 
{
	global $_GET;
	global $PGM_SESSION;
	global $CFG, $ME;

	if (!isset($_GET["page_number"])) {
		$page_number = 1;
	} else {
		$page_number = max(1, abs(intval($_GET["page_number"])));
	}

	$qid = new PGM_Sql("SELECT COUNT(id) AS cnt FROM download");
	$qid->next_record();

	include ($CFG["libdir"] . "pgm_pager.inc.php");
	$result = pgm_pager($ME, $qid->f("cnt"), $CFG["list_item_per_page"], $page_number);
	$limit = $result["last"] - $result["first"] + 1;
	$limit_clause = prepare_limit_clause($limit, $result["first"]);

	$qid = new PGM_Sql();
	$qid->query("
		SELECT * FROM download ORDER BY id
		$limit_clause
	");

	$t = new Template();
	$t->set_file("page","templates/download_list.ihtml");
	
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");

	/*$t->set_var(array(
		"cfg_myname"	=> $CFG["myname"],
		"wwwroot"	=> $CFG["wwwroot"]
	));*/

	$t->set_block("page", "file_row", "file_row_blck");
	$t->set_var("file_row_blck", "");
	$t->set_block("page", "pages_links_bottom", "pages_links_bottom_blck");
	$t->set_var("pages_links_bottom_blck", "");
	if ($result["num_pages"] > 1) {
		$t->set_var("pages_links", $result["html"]);
		$t->parse("pages_links_bottom_blck", "pages_links_bottom", true);
	}
	while ($qid->next_record()) {
		$t->set_var(array(
			"id"		=> $qid->f("id"),
			"name"		=> ov($qid->f("name")),
			"description"	=> ovwbr($qid->f("description")),
			"filetype"	=> $qid->f("filetype")
		));
		$t->parse("file_row_blck", "file_row", true);
	}

	$t->pparse("out", "page");

	pgm_session_close($PGM_SESSION, $session_name);

}

?>
