<?php
// (C)2005 Matteo Lucarelli

include ("../config.inc.php");
include ("../common.inc.php");
require_login();
require_priv("admin");

$DOC_TITLE = "News_Management";
include ("../header.php");

if ($_SERVER["REQUEST_METHOD"] == "GET") {
	$id = nvl($_GET["id"], 1);
	$mode = nvl($_GET["mode"], "");
}
if ($_SERVER["REQUEST_METHOD"] == "POST") {
	$id = nvl($_POST["id"], 0);
	$mode = nvl($_POST["mode"], "");
}

switch (nvl($mode)) {
	case "add":
		print_add_news_form();
		break;

	case "del":
		delete_news($id);
		break;
		
	case "insert":
		insert_news($_POST);
		break;
	default:
		list_news();
		break;
}

include ("../footer.php");

pgm_session_close($PGM_SESSION, $session_name);

/* *******************************************************************
 * FUNCTIONS
 ****************************************************************** */

function load_news_form_template($frm, $errors) {
	global $CFG;

	$t = new Template();
	$t->set_file("page", "templates/news_form.ihtml");
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");
	$t->set_var("star", return_star());
	$t->set_var(array(
		"frm_newmode"		=> $frm["newmode"],
		"id"			=> nvl($frm["id"]),
		"frm_name"		=> ov($frm["name"]),
		"errors_name"		=> errmsg(nvl($errors["name"], "")),
		"frm_date"		=> ov($frm["date"]),
		"errors_date"		=> errmsg(nvl($errors["date"], "")),
		"frm_description"	=> ov($frm["description"]),
		"errors_file"		=> errmsg(nvl($errors["file"], "")),
		"frm_submit_caption"	=> $t->get_var($frm["submit_caption"])
	));
	
	$t->pparse("out", "page");
}

function print_add_news_form() 
{
	// set default values for the reset of the fields
	$frm["newmode"] = "insert";
	$frm["name"] = "";
	$frm["date"] = "";
	$frm["description"] = "";
	$frm["submit_caption"] = "Add_News";
	$errors = array();

	load_news_form_template($frm, $errors);
}

function insert_news($frm) {

	global $_FILES;
	global $PGM_SESSION;
	global $CFG;

	while (list($key, $val) = each($frm)) {
		if (is_string($val)) $frm[$key] = addslashes($val);
	}
	
	$errors = array();
	$errormsg = "";
		
	include ($CFG["globalerror"]);
	if ($frm[name] == "") {
		$errors["name"] = true;
		$errormsg .= "<li>" . $empty_name;
	}
	if ($frm[date] == "") {
		$errors["date"] = true;
		$errormsg .= "<li>" . $empty_date;
	}

	if ( $_FILES["imagesrc"]["name"] != "" ){
	
		$filename = basename( $_FILES["imagesrc"]["name"] );
		$upload_file_name = $CFG["newsdir"] . $filename;
	
		if (!move_uploaded_file($_FILES["imagesrc"]["tmp_name"], $upload_file_name)) {
			$errors["file"] = true;
			$errormsg = "<li>" . $import_file_upload_failed;
		}
	}
		
	if ($errormsg == "") {
		if ($upload_file_name!="") chmod ($upload_file_name, 0644);
		$qid = new PGM_Sql();
		$qid->lock("news");
		$qid->query("
			INSERT INTO news (
				 imagesrc
				,name
				,description
				,date
			)
			VALUES (
				 '" . $filename . "'
				,'" . $frm["name"] . "'
				,'" . $frm["description"] . "'
				,'" . $frm["date"] . "'
			)
		");
		$qid->unlock();
		list_news();
	} else {
		// set default values for the reset of the fields
		$frm = $_POST;
		$frm["newmode"] = "insert";
		$frm["submit_caption"] = "Add_News";
		
		include ($CFG["dirroot"] . "form_header.php");
		load_news_form_template($frm, $errors);
	}
}

function delete_news($id) {

	global $PGM_SESSION;
	global $CFG;
	
	$qid = new PGM_Sql();
	$qid->query("SELECT imagesrc FROM news WHERE id = '$id'");
	$qid->next_record();
	
	$filename = $CFG["newsdir"] . $qid->f("imagesrc");
	
//	if ($CFG["unix"]) {
		// Note: This function may not work on Windows systems.
		//unlink ($filename);

//	} else system ($CFG["rmf"] . " " . $old_image_name, $result);

	$qid->begin();
	$qid->query("DELETE FROM news WHERE id = '$id'");
	$qid->commit();
	
	list_news();
}


function list_news() 
{
	global $_GET;
	global $PGM_SESSION;
	global $CFG, $ME;

	if (!isset($_GET["page_number"])) {
		$page_number = 1;
	} else {
		$page_number = max(1, abs(intval($_GET["page_number"])));
	}

	$qid = new PGM_Sql("SELECT COUNT(id) AS cnt FROM news");
	$qid->next_record();

	include ($CFG["libdir"] . "pgm_pager.inc.php");
	$result = pgm_pager($ME, $qid->f("cnt"), $CFG["list_item_per_page"], $page_number);
	$limit = $result["last"] - $result["first"] + 1;
	$limit_clause = prepare_limit_clause($limit, $result["first"]);

	$qid = new PGM_Sql();
	$qid->query("
		SELECT * FROM news ORDER BY id
		$limit_clause
	");

	$t = new Template();
	$t->set_file("page","templates/news_list.ihtml");
	
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");

	/*$t->set_var(array(
		"cfg_myname"	=> $CFG["myname"],
		"wwwroot"	=> $CFG["wwwroot"]
	));*/

	$t->set_block("page", "file_row", "file_row_blck");
	$t->set_var("file_row_blck", "");
	$t->set_block("page", "pages_links_bottom", "pages_links_bottom_blck");
	$t->set_var("pages_links_bottom_blck", "");
	if ($result["num_pages"] > 1) {
		$t->set_var("pages_links", $result["html"]);
		$t->parse("pages_links_bottom_blck", "pages_links_bottom", true);
	}
	while ($qid->next_record()) {
		$t->set_var(array(
			"id"		=> $qid->f("id"),
			"name"		=> $qid->f("name"),
			"date"		=> $qid->f("date"),
		));
		$t->parse("file_row_blck", "file_row", true);
	}
	$t->pparse("out", "page");

	pgm_session_close($PGM_SESSION, $session_name);

}

?>
