<?php
// (C) 2005 Matteo Lucarelli <matteo@matteolucarelli.net>
// (C) 2000-2003 Marco Pratesi <marco@pgmarket.net>
// (C) 2000 Ying Zhang (ying@zippydesign.com)

// this file defines the CFG array containing configuration values
// for all the flags 0-> no, 1-> yes

$CFG = array();

//$CFG["dbms"] = "pgsql"; // uncomment to use PostgreSQL
$CFG["dbms"] = "mysql"; // uncomment to use MySQL

// language ID is used to build locale path 
$CFG["available_languages"] = array("it", "en");

// to automatically choose the browser's preferred language
// among the available ones, relying on HTTP_ACCEPT_LANGUAGE
// if the language session variable is still not defined
$CFG["use_http_accept_language"] = 1;

$CFG["base_lang"] = "it";
$CFG["yes"] = "si";
$CFG["default_i18n"] = "en";	// The default internazionalization language

$CFG["admin_language_used"] = 0;

$session_name = "pgm_example_session";	// not significant if PHP 4.0 is used

// all directories stored in $CFG must be indicated with an ending "/"
$CFG["wwwroot"]		= "/pgmreloaded-0.6.2/pgm/";
$CFG["dirroot"]		= "/var/www/pgmreloaded-0.6.2/pgm/";
$CFG["firstpage"]	= $CFG["wwwroot"] . "index.php";
$CFG["libdir"]		= $CFG["dirroot"] . "lib/";
$CFG["libwww"]		= $CFG["wwwroot"] . "lib/";
$CFG["localedir"]	= $CFG["dirroot"] . "locale/";
$CFG["productswww"]	= $CFG["wwwroot"] . "var/catalog_img/";
$CFG["productsdir"]	= $CFG["dirroot"] . "var/catalog_img/";
$CFG["imageswww"]	= $CFG["wwwroot"] . "images/";
$CFG["imagesdir"]	= $CFG["dirroot"] . "images/";
$CFG["downloadwww"]	= $CFG["wwwroot"] . "var/download/";
$CFG["downloaddir"]	= $CFG["dirroot"] . "var/download/";
$CFG["newswww"]		= $CFG["wwwroot"] . "var/news/";
$CFG["newsdir"]		= $CFG["dirroot"] . "var/news/";

$CFG["myname"] = "PgmReloaded";

$CFG["support"]		= "support@yoursite";
$CFG["seller_fullname"]	= "seller";
$CFG["seller_email"]	= "seller@yoursite";

$CFG["email_subject"]		= "PgmReloaded: Richiesta d'offerta";
$CFG["email_subject_agent"]	= "PgmReloaded: ORDINE";

$CFG["price_used"] = 1;
$CFG["currency"] = "&euro;";	// not significant if prices not used
$CFG["price_must_be_integer"] = 0;	// not significant if prices not used
$CFG["iva_used"] = 0;		// IVA, i.e. VAT (not significant if prices not used)
$CFG["IVA"] = "IVA";
$CFG["weight_used"] = 0;
$CFG["weight_unit"] = "Kg";	// not significant if weight is not used
$CFG["max_weight"] = 10000.0;	// not significant if weight is not used
$CFG["delivery_used"] = 1;
$CFG["only_one_delivery_zone"] = 0;	// set it to 1 if you will use only the default delivery zone, with id = 1
$CFG["user_discount_used"] = 0;	// not significant if prices not used
$CFG["order_state_used"] = 1;  // if use or not the order state
$CFG["variant_used"] = 1;            // if use or not products variants

$CFG["max_file_size_images"] = 500000;		// upload of product images
$CFG["max_file_size_import"] = 10000000;	// upload of import files
$CFG["max_file_size_tables_data"] = 10000000;	// upload of import files

// to browse the catalog you have to chose one or more between:
// layermenu: the menu on the left bar
// treemenu : the filebrowser-like on catalog pages
// subcategories: the categories list on catalog
$CFG["layersmenu_used"] = 1;
$CFG["layersmenu_cached"] = 0; // TODO bug if 1
$CFG["treemenu_used"] = 1;
$CFG["subcategories_used"] = 1;

$CFG["rmf"] = "rm -f";
$CFG["rmrf"] = "rm -rf";
$CFG["unix"] = 1;
//$CFG["rmf"] = "del";		// for Windows
//$CFG["rmrf"] = "deltree";	// for Windows
//$CFG["unix"] = 0;		// for Windows

$CFG["create_thumbs"] = 1;	// do you want to enable generation of thumbs on the fly?
// Note: if safe_mode is enabled and/or the open_basedir restriction
// is in effect, you are not able to use ImageMagick and netpbm + libjpeg
$CFG["use_imagemagick"] = 1;	// Do you want to use ImageMagick to generate thumbs on the fly?
$CFG["use_libgd"] = 0;		// Do you want to use PHP libgd support to generate thumbs on the fly?
$CFG["use_netpbm"] = 0;		// Do you want to use netpbm + libjpeg to generate thumbs on the fly?
$CFG["thumbwidthlimit"] = 100;  // these are limit to preserve aspect ratio
$CFG["thumbheightlimit"] = 100;

// the commands path on the server (with an ending "/")
$CFG["imagemagick_path"] = "/usr/bin/";
$CFG["netpbm_path"] = "/usr/bin/";
$CFG["libjpeg_path"] = "/usr/bin/";

// set it to 0 if you want to store product images and thumbs in the DB
$CFG["images_on_file_system"] = 0;

// max number of items per page in lists
$CFG["products_per_catalog_page"] = 5;	// catalog pages, search results
$CFG["products_per_page"] = 10;		// admin products page
$CFG["categories_per_page"] = 5;	// admin categories page
$CFG["orders_per_page"] = 5;		// admin and users orders pages
$CFG["list_item_per_page"] = 15;	// all the other lists

$CFG["max_results"] = 100;		// max number of search results to accept the search request

$CFG["user_discount_name_length"] = 100;
$CFG["zone_code_length"] = 10;
$CFG["zone_name_length"] = 100;
$CFG["username_length"] = 16;
$CFG["username_length_min"] = 6;
$CFG["password_length"] = 32;
$CFG["priv_length"] = 5;
$CFG["fiscalcode_length"] = 16;
$CFG["partitaiva_length"] = 11;
$CFG["address_length"] = 255;
$CFG["number_length"] = 50;
$CFG["zip_code_length"] = 5; // for Italy (CAP)
$CFG["zip_code_length_max"] = 10;
$CFG["zip_code_length_min"] = 4;
$CFG["city_length"] = 100;
$CFG["country_length"] = 100;
$CFG["phone_length"] = 32;
$CFG["phone_length_min"] = 5;
$CFG["fax_length"] = 32;
$CFG["fax_length_min"] = 5;
$CFG["mobilephone_length"] = 32;
$CFG["mobilephone_length_min"] = 5;
$CFG["email_length"] = 128;
$CFG["notes_length"] = 500;
$CFG["message_length"] = 5000;
$CFG["ournotes_length"] = 500;
$CFG["comments_length"] = 500;
$CFG["lang_length"] = 15;
$CFG["category_name_length"] = 100;
$CFG["product_code_length"] = 25;

$CFG["discqtymax"] = 1000;

$CFG["firstname_length"] = 64;
$CFG["lastname_length"] = 64;
$CFG["name_length"] = 64;
$CFG["order_state_name_length"] = 100;
$CFG["product_name_length"] = 100;

$CFG["iva_description_length"] = 255;
$CFG["category_description_length"] = 255;
$CFG["product_description_length"] = 500;
$CFG["product_extended_description_length"] = 2000;
$CFG["zone_description_length"] = 255;
$CFG["user_discount_description_length"] = 255;
$CFG["order_state_description_length"] = 255;

function print_formatted_price($price) {
	global $CFG;
	echo $CFG["currency"] . " " . number_format ($price, 2, ".", ",");
}
function formatted_price($price) {
	global $CFG;
	return $CFG["currency"] . " " . number_format ($price, 2, ".", ",");
}
function formatted_price_text($price) {
	global $CFG;
	return "Euro " . number_format ($price, 2, ".", ",");
}

function print_formatted_weight($weight) {
	echo number_format ($weight, 2, ",", ".");
//	echo number_format ($weight, 2, ".", ",");
}
function formatted_weight($weight) {
	return number_format ($weight, 2, ",", ".");
//	return number_format ($weight, 2, ".", ",");
}

if (!isset($_SERVER)) $_SERVER = $HTTP_SERVER_VARS;	// For CoMPaTiBiLiTy with PHP 4.0
if (!isset($_GET)) $_GET = $HTTP_GET_VARS;		// For CoMPaTiBiLiTy with PHP 4.0
if (!isset($_POST)) $_POST = $HTTP_POST_VARS;		// For CoMPaTiBiLiTy with PHP 4.0
if (!isset($_COOKIE)) $_COOKIE = $HTTP_COOKIE_VARS;	// For CoMPaTiBiLiTy with PHP 4.0
if (!isset($_FILES)) $_FILES = $HTTP_POST_FILES;	// For CoMPaTiBiLiTy with PHP 4.0
if (!isset($_ENV)) $_ENV = $HTTP_ENV_VARS;		// For CoMPaTiBiLiTy with PHP 4.0

?>
