<?php
// (C) 2005 Matteo Lucarelli
// (C) 2000-2002 Marco Pratesi <marco@pgmarket.net>
// (C) 2000 Ying Zhang (ying@zippydesign.com)

include ("config.inc.php");
include ("common.inc.php");

$DOC_TITLE = "PgMarket_Home_Page";
include ($CFG["dirroot"] . "header.php");

$qid = new PGM_Sql();

// query for special products
$qid->pgm_lang_join_query(
	$CFG["base_lang"],
	array("products p", "products_i18n l"),
	array(array("p.id", "l.product_id", 1, $PGM_SESSION["lang"])),
	array(array("l.name AS lname",  "l.description AS ldescription")),
	"p.id, p.name, p.price, i.iva, p.discount, p.discqty, p.weight, p.special_level, p.description, p.thumbtype, p.thumbwidth, p.thumbheight",
	"iva i",
	"p.iva_id = i.id AND special_flag = 1",
	"special_level ASC",
	array()
);

$t = new Template(".", "keep");
include ($CFG["localelangdir"] . "global-common.inc.php");
include ($CFG["localelangdir"] . "global-shopping.inc.php");
$t->set_file(array(
	"page"			=> "templates/" . $PGM_SESSION["lang"] . "/index.ihtml",
	"special_products"	=> "templates/special_products.ihtml"
));
$t->set_var(array(
	"cfg_myname"	=> $CFG["myname"],
	"wwwroot"	=> $CFG["wwwroot"]
));
$t->set_block("page", "there_are_special_products", "there_are_special_products_blck");
if (!($qid->num_rows() > 0)) {
	$t->set_var("there_are_special_products_blck", "");
} else {
	$t->set_block("special_products", "special_products_product", "special_products_products");
	$t->set_var(array("special_products_products" => ""));
		$t->set_block("special_products_product", "prodthumb", "prodthumb_blck");
		$t->set_block("special_products_product", "price_used", "price_used_blck");
		$t->set_block("price_used", "user_discount_used", "user_discount_used_blck");
		$t->set_block("price_used", "discount_block", "discount_block_blck");
			$t->set_block("discount_block", "discqty_block", "discqty_block_blck");
	while ($qid->next_record()) {
		$t->set_var("price_used_blck", "");
		$t->set_var("prodthumb_blck", "");
		$t->set_var("user_discount_used_blck", "");
		$t->set_var("discount_block_blck", "");
			$t->set_var("discqty_block_blck", "");
		
		$t->set_var(array(
			"product_id"	=> $qid->f("id"),
			"pname"		=> ($qid->f("lname") != "") ? $qid->f("lname") : $qid->f("name"),
			"description"	=> ($qid->f("ldescription") != "") ? ovwbr($qid->f("ldescription")) : ovwbr($qid->f("description")),
			"fprice"	=> formatted_price($qid->f("price"))
		));
		//if ($CFG["price_used"] && $qid->f("bname") != "") 
		if ($CFG["price_used"])
			$t->parse("price_used_blck", "price_used");

		if ($CFG["images_on_file_system"] && file_exists($CFG["productsdir"] . $qid->f("id") . ".thumb." . $qid->f("thumbtype"))) {
			$t->set_var(array(
				"thumbwidth"	=> $qid->f("thumbwidth"),
				"thumbheight"	=> $qid->f("thumbheight")
			));
			if (has_priv("admin")) {
				$t->set_var("thumbsrc", $CFG["wwwroot"] . "admin/getimage.php?image=" . $qid->f("id") . ".thumb." . $qid->f("thumbtype") . "&amp;type=" . $qid->f("thumbtype"));
			} else {
				$t->set_var("thumbsrc", $CFG["productswww"] . $qid->f("id") . ".thumb." . $qid->f("thumbtype"));
			}
			$t->parse("prodthumb_blck", "prodthumb", true);
		} else if (!$CFG["images_on_file_system"] && $qid->f("thumbtype") != "") {
			$t->set_var(array(
				"thumbwidth"	=> $qid->f("thumbwidth"),
				"thumbheight"	=> $qid->f("thumbheight")
			));
			if (has_priv("admin")) {
				$t->set_var("thumbsrc", $CFG["wwwroot"] . "admin/dbgetimage.php?type=thumb&from=products&id=" . $qid->f("id"));
			} else {
				$t->set_var("thumbsrc", $CFG["wwwroot"] . "dbgetimage.php?type=thumb&from=products&id=" . $qid->f("id"));
			}
			$t->parse("prodthumb_blck", "prodthumb", true);
		}
		if ($CFG["user_discount_used"] && is_logged_in() && $PGM_SESSION["user"]["user_discount"] > 0) {
			$t->set_var(array(
				"user_discount"		=> $PGM_SESSION["user"]["user_discount"],
				"discounted_price"	=> formatted_price((1.0-$PGM_SESSION["user"]["user_discount"]/100.0)*$qid->f("price"))
			));
			$t->parse("user_discount_used_blck", "user_discount_used", true);
		}
		if ($qid->f("discount") > 0) {
			$t->set_var("discount", $qid->f("discount"));
			if ($qid->f("discqty") > 1) {
				$t->set_var("discqty", $qid->f("discqty"));
				$t->parse("discqty_block_blck", "discqty_block", true);
			}
			$t->parse("discount_block_blck", "discount_block", true);
		}
		$t->parse("special_products_products", "special_products_product", true);
	}
	$t->parse("there_are_special_products_blck", "there_are_special_products", true);
}
$t->pparse("out", array("special_products", "page"));

//$t->parse("out", "special_products");
//$t->parse("out", "page");
//$t->p("out");

include ($CFG["dirroot"] . "footer.php");

pgm_session_close($PGM_SESSION, $session_name);

?>
