<?php
// (C) 2005 Matteo Lucarelli
// (C) 2000-2002 Marco Pratesi <marco@pgmarket.net>
// (C) 2000 Ying Zhang (ying@zippydesign.com)
// (C) 2001 Fabio Molinari <fabio.m@mclink.it>

/**
* It finds the path of the product categories, starting from the given category and ending with the Top
* @param integer $id the category id for which the category path
*   has to be found
* @param string $category_path the string that stores the resulting
*   category path
* @returns void
*/
function build_category_path($id=1, &$category_path) {
	global $PGM_SESSION;
	global $CFG;

	$qid = new PGM_Sql();
	$first=TRUE;
	
	while ($id > 1) {
		$qid->pgm_lang_join_query(
			$CFG["base_lang"],
			array("categories c", "categories_i18n l"),
			array(array("c.id", "l.category_id", 1, $PGM_SESSION["lang"])),
			array(array("l.name AS lname")),
			"c.parent_id, c.name",
			"",
			"c.id = '$id'",
			"",
			array()
		);
		if ($qid->num_rows()) {
			$qid->next_record();
			$parent = $qid->f("parent_id");
			$name = ($qid->f("lname") != "") ? $qid->f("lname") : $qid->f("name");
			$name = "<a href=\"" . $CFG["wwwroot"] . "shopping/index.php?id=$id\">" . stripslashes($name) . "</a>";
			
			if ($first){
				$first=FALSE;
				$name="<i>".$name."</i>";
			}
			$category_path = $name . " &gt; " . $category_path;
		} else {
			$parent = 1;
			$name = "";
		}
		$id = $parent;
	}
	if ($category_path=="") $category_path="&nbsp;";
}

function get_zone_name(&$qid, $zone_id) {
	global $PGM_SESSION;
	global $CFG;

	$qid->pgm_lang_join_query(
		$CFG["base_lang"],
		array("zones z", "zones_i18n l"),
		array(array("z.id", "l.zone_id", 1, $PGM_SESSION["lang"])),
		array(array("l.name AS lname")),
		"z.id AS zone_id, z.name",
		"",
		"id = '$zone_id'",
		"",
		array()
	);
}

function get_zones_names(&$qid) {
	global $PGM_SESSION;
	global $CFG;

	$qid->pgm_lang_join_query(
		$CFG["base_lang"],
		array("zones z", "zones_i18n l"),
		array(array("z.id", "l.zone_id", 1, $PGM_SESSION["lang"])),
		array(array("l.name AS lname")),
		"z.id AS zone_id, z.name",
		"",
		"",
		"name",
		array()
	);
}

function refresh_cache() {
	global $PGM_SESSION;
	global $CFG;
	include_once ($CFG["libdir"] . "phplayersmenu/layersmenu.inc.php");

	$save_lang = $PGM_SESSION["lang"];

	$qid = new PGM_Sql("SELECT lang FROM languages");
	$languages = array();
	$languages[0] = $CFG["base_lang"];
	$i = 0;
	while ($qid->next_record()) {
		$i++;
		$languages[$i] = $qid->f("lang");
	}
	$num_languages = count($languages);

	$qid->query("DELETE FROM cache");

	for ($i=0; $i<$num_languages; $i++) {
		$PGM_SESSION["lang"] = $languages[$i];
		build_catbrowser_js($categories);
		if ($categories != "") {
			$mid = new LayersMenu(100);
			$mid->set_separator("^");
			$mid->set_dirroot($CFG["dirroot"]);
			$mid->set_libdir($CFG["libdir"] . "phplayersmenu/");
			$mid->set_libwww($CFG["libwww"] . "phplayersmenu/");
			$mid->set_tpldir($CFG["dirroot"] . "templates/");
			$mid->set_imgdir($CFG["imagesdir"]);
			$mid->set_imgwww($CFG["imageswww"]);
			$mid->set_forward_arrow_img("forward-gnome.png");
			$mid->set_vertical_menu_tpl("layersmenu-vertical_menu.ihtml");
			$mid->set_sub_menu_tpl("layersmenu-sub_menu.ihtml");
			$mid->set_menu_structure_string($categories);
			$mid->parse_menu_structure("vermenu");
			$mid->new_vertical_menu("vermenu");
			$qid->query("
				INSERT INTO cache (
					 lang
					,header
					,first_level_menu
					,footer
				)
				VALUES (
					 '" . $PGM_SESSION["lang"] . "'
					,'" . addslashes($mid->make_header()) . "'
					,'" . addslashes($mid->get_menu("vermenu")) . "'
					,'" . addslashes($mid->make_footer()) . "'
				)
			");
		}
	}

	$PGM_SESSION["lang"] = $save_lang;
}

function return_star() {
	return "<font color=\"#ff0000\">*</font>";
}

/* if $errorvar is set, then returns an error marker << */
function errmsg($errorvar) {
	if ($errorvar) {
		return "<font color=\"#ff0000\">&lt;&lt;</font>";
	}
}

/* like errmsg(), but returns the marker >> */
function errmsg2($errorvar) {
	if ($errorvar) {
		return "<font color=\"#ff0000\">&gt;&gt;</font>";
	}
}

function getmicrotime(){
	list($usec, $sec) = explode(" ", microtime());
	return ((float) $usec + (float) $sec);
}

/**
* Generates on the fly a thumb of the full size image
* @param string $image_filename filename (with the path) of the full size image
* @param array $imagesize array related to the full size image and resulting
*   from getimagesize()
* @param string $thumb_filename filename (with the path) of the thumb
*   to be generated
* @param array $thumbsize analogous to $imagesize, it is passed by reference
*   to return values related to the thumb
* @return boolean
*/
function create_thumb($image_filename, $imagesize, $thumb_filename, &$thumbsize) {
	global $CFG;
	include ($CFG["globalerror"]);

	if ($CFG["use_imagemagick"]) {
		system ("\"" . $CFG["imagemagick_path"] . "convert" . 
			"\" -geometry " . $CFG[thumbwidthlimit] . "x" . $CFG[thumbheightlimit] . 
			" -quality 85 $image_filename $thumb_filename", $result);
		if (file_exists($thumb_filename . ".0")) {
			rename ($thumb_filename . ".0", $thumb_filename);
			system ($CFG["rmf"] . " " . $thumb_filename . ".*");
		}
		$thumbsize = getimagesize ($thumb_filename);
		return true;
	} else if ($CFG["use_libgd"]) {
		switch ($imagesize[2]) {
			case 1:
				$thumbsize[0] = 0;
				$thumbsize[1] = 0;
				error($gifs_are_not_supported_by_libgd);
				return false;
				break;
			case 2:
				$src_img = imagecreatefromjpeg($image_filename);
				break;
			case 3:
				$src_img = imagecreatefrompng($image_filename);
				break;
		}
		$imagewidth = $imagesize[0];
		$imageheight = $imagesize[1];
		$thumbwidth = min( $CFG[thumbwidthlimit] , (int) ($imagewidth/$imageheight*$CFG[thumbheightlimit] + 0.5));
		$thumbheight = min( $CFG[thumbheightlimit], (int) ($imageheight/$imagewidth*$CFG[thumbwidthlimit] + 0.5));
		$dst_img = imagecreate($thumbwidth, $thumbheight);
		imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, $thumbwidth, $thumbheight, $imagewidth, $imageheight);
		imagejpeg($dst_img, $thumb_filename);
		imagedestroy($dst_img);
		$thumbsize[0] = $thumbwidth;
		$thumbsize[1] = $thumbheight;
		return true;
	} else if ($CFG["use_netpbm"]) {
		switch ($imagesize[2]) {
			case 1:
				$convert = $CFG["netpbm_path"] . "giftopnm";
				break;
			case 2:
				$convert = $CFG["libjpeg_path"] . "djpeg";
				break;
			case 3:
				$convert = $CFG["netpbm_path"] . "pngtopnm";
				break;
		}
		system ($convert . " " . $image_filename . " | " .
			$CFG["netpbm_path"] . "pnmscale -xysize " . 
			$CFG[thumbwidthlimit] . " " . $CFG[thumbheightlimit] .  " | " .
			$CFG["libjpeg_path"] . "cjpeg -optimize -progressive -quality 85 > $thumb_filename",
			$result
		);
		$thumbsize = getimagesize ($thumb_filename);
		return true;
	}

	return false;
}

?>
