<?php
// (C)2005 Matteo Lucarelli

/*
$variant_ary = array();
$variant_str = "aa |      bb| cc \n\n 1|2|3\n\n\n";

$variant_ary= variant_str2ary($variant_str,&$totcol,&$totrow,&$maxfield);
echo $totcol."\n";
echo $totrow."\n";
echo $maxfield."\n";

$str=variant_ary2str($variant_ary,$totcol,$totrow);
echo $str."\n";

$str=format_variant_str(variant_ary2str($variant_ary,$totcol,$totrow));
echo $str."\n";

$str=pgm_buildviewvarianttable($variant_str);
echo $str."\n";

$str=pgm_buildshoppingvarianttable($variant_str);
echo $str."\n";
*/


// build array from string (col separator=| row separator=\n) 
function variant_str2ary($variant_str,$totcol,$totrow,$maxfield=NULL){

	$variant_ary = array();
	$col=0;
	$row=0;
	$elem=0;
	$totcol=0;
	$totrow=0;
	$maxfield=0;
	$labelstarted=FALSE;
	$newline=FALSE;
	$len=strlen($variant_str);
	for ($i=0; $i<$len; $i++){
		$ch=substr($variant_str,$i,1);
		if ($ch=="|"){
			$col++;
			if ($elem>$maxfield) $maxfield=$elem;
			$elem=0;
			$labelstarted=FALSE;
		}
		else if (($ch=="\n")||($ch=="\r")){
			if ($col>0) $row++;
			if ($col>$totcol) $totcol=$col;
			$col=0;
			$elem=0;
			$labelstarted=FALSE;
		}
		else if (($ch!=" ")||($labelstarted==TRUE)){
			$labelstarted=TRUE;
			$variant_ary[$row][$col].=$ch;
			$elem++;
		}
		
	}
	if ($col>$totcol) $totcol=$col;
	$totrow=$row;
	if ($col>0) $totrow++;
	$totcol++;
	return $variant_ary;
}

// build string from array
function variant_ary2str($variant_ary,$totcol,$totrow){
	
	$variant_str="";
	for ($row=0;$row<$totrow;$row++){
		for ($col=0;$col<$totcol-1;$col++){
			$variant_str.=sprintf("%s|",$variant_ary[$row][$col]);
		}
		if ($row<($totrow-1))
			$variant_str.=sprintf("%s\n",$variant_ary[$row][$col]);
		else $variant_str.=sprintf("%s",$variant_ary[$row][$col]);	
	}
	return $variant_str;
}

// validate variant table in string format
function validate_variant_str($variant_str, $errors, $errormsg){
	
}

function variant_remove_blanks($variant_str){
	return $variant_str;
}

// format variant string for best viewing
function format_variant_str($variant_str)
{
	$variant_ary = array();
	$variant_ary=variant_str2ary($variant_str,&$totcol,&$totrow,&$maxfield);
	$f_str="";

	$format=sprintf("%%%ds|",$maxfield);
	$formatlc=sprintf("%%%ds\n",$maxfield);
	$formatlr=sprintf("%%%ds",$maxfield);

	for ($row=0;$row<$totrow;$row++){
		for ($col=0;$col<$totcol-1;$col++){
			$f_str.=sprintf($format,$variant_ary[$row][$col]);
		}
		if ($row<($totrow-1))
			$f_str.=sprintf($formatlc,$variant_ary[$row][$col]);
		else $f_str.=sprintf($formatlr,$variant_ary[$row][$col]);	
	}
	return $f_str;
}

// this creates variant table for shopping (with "add to cart" commands)
function pgm_buildshoppingvarianttable($variant_str)
{
	$variant_ary = array();
	$variant_ary=variant_str2ary($variant_str,&$col,&$row);
	
	$html_output = "<form action=\"shopping_cart_add.php\" method=\"post\">";
	$html_output .= "<input type=\"hidden\" name=\"product_id\" value=\"{product_id}\">";
	$html_output .= "<input type=\"hidden\" name=\"variant_rows\" value=\"$row\">\n";
	$html_output .= "<input type=\"hidden\" name=\"variant_column\" value=\"$col\">\n";

	if ($row*$col>0){
	
		for ($r=1;$r<$row;$r++)
			$html_output .= sprintf("<input type=\"hidden\" name=\"variant%s\" value=\"%s\">\n",$r,$variant_ary[$r][0]);
	
		$html_output .= "<h3>{Variant_Table}</h3><table><tr><td></td>\n";
		for ($c=0;$c<$col;$c++){
			$html_output .= sprintf("<th>%s</th>",$variant_ary[0][$c]);
		}
		$html_output .= "</tr>\n";

		for ($r=1;$r<$row;$r++){
			$html_output .= "<tr>";
			for ($c=-1;$c<$col;$c++){
				if ($c==-1) $html_output .= "<td class=\"label\"><input type=\"text\" size=\"4\" name=\"qty$r\" value=\"0\"></td>";
				else $html_output .= sprintf("<td>%s</td>",$variant_ary[$r][$c]);
			}		
			$html_output .= "</tr>\n";
		}
		$html_output .= "</table>\n<br><input type=\"submit\" class=\"button\" value=\"{Add_to_cart}\">";
	}
	
	$ret = array();
	$ret[html]=$html_output;
	$ret[col]=$col;
	$ret[row]=$row;

	return $ret;
}

// this creates a well-done variant table view-only from variant str
function pgm_buildviewvarianttable($variant_str)
{
	$variant_ary = array();
	$variant_ary=variant_str2ary($variant_str,&$col,&$row);
	
	$html_output = "<input type=\"hidden\" name=\"variant_rows\" value=\"$row\">\n";
	$html_output .= "<input type=\"hidden\" name=\"variant_column\" value=\"$col\">\n";

	if ($row*$col>0){		
		$html_output .= "<h3>{Variant_Table}</h3><table><tr>\n";
		$r=0;
		for ($c=0;$c<$col;$c++){
			$html_output .= sprintf("<th>%s</th>",$variant_ary[$r][$c]);
		}		
		$html_output .= "</tr>\n";
		for ($r=1;$r<$row;$r++){
			$html_output .= "<tr>";
			for ($c=0;$c<$col;$c++){
				$html_output .= sprintf("<td>%s</td>",$variant_ary[$r][$c]);
			}		
			$html_output .= "</tr>\n";
		}
		
		$html_output .= "</table>\n";
	}
	
	$ret = array();
	$ret[html]=$html_output;
	$ret[col]=$col;
	$ret[row]=$row;

	return $ret;
}

?>
