<?php
// (C) 2000 Ying Zhang (ying@zippydesign.com)
// (C) 2000-2003 Marco Pratesi <marco@pgmarket.net>

include ("../config.inc.php");
include ("../common.inc.php");
require_login();
include ($CFG["libdir"] . "pgm_orders.inc.php");

/* this page will do the CC authentication, so we want to try to prevent
 * people from entering here casually */

$cart_is_empty = ($PGM_SESSION["CART"]->num_items() == 0);
$order = load_orderinfo();
if ($cart_is_empty || !$order) {
	pgm_session_close($PGM_SESSION, $session_name);
	redirect($CFG["firstpage"]);
	die;
}

/*
if is a credit card payment add here the form for
Payment Authorization Service
*/

$t = new Template();
include ($CFG["localelangdir"] . "global-common.inc.php");

$DOC_TITLE = "Order_Completed_Successfully";
include($CFG["dirroot"] . "header.php");

$t = new Template();
include ($CFG["localelangdir"] . "global-common.inc.php");
include ($CFG["localelangdir"] . "global-shopping.inc.php");
include ($CFG["localelangdir"] . "global-admin.inc.php");

/* we will create the order in our database, then try to authorize the
* payment.  if all was successful, the user's order will have been
* completed.
*/
$emailbody = "";
$orderid = create_order($order, $emailbody);

if (has_priv("agent")){
	mail(
		$CFG["seller_fullname"] . " <" . $CFG["seller_email"] . ">",
		$CFG["email_subject_agent"],
		$emailbody,
		"From: " . $PGM_SESSION["user"]["email"]
	);
}else{
	mail(
		$CFG["seller_fullname"] . " <" . $CFG["seller_email"] . ">",
		$CFG["email_subject"],
		$emailbody,
		"From: " . $PGM_SESSION["user"]["email"]
	);
}


$t->set_file("page", "templates/" . $PGM_SESSION["lang"] . "/complete_order_success.ihtml");
$t->set_var(array(
		"orderid"	=> $orderid,
		"fgrandtotal"	=> formatted_price($PGM_SESSION["CART"]->get_grandtotal()),
		"firstpage"	=> $CFG["firstpage"],
		"myname"	=> $CFG["myname"],
		"wwwroot"	=> $CFG["wwwroot"],		
));
$t->set_block("page", "price_used", "price_used_blck");
$t->set_var("price_used_blck", "");
if ($CFG["price_used"]) $t->parse("price_used_blck", "price_used", true);
/* clear out the shopping cart, so the user doesn't accidentally re-submit
* and purchase twice!! */
$PGM_SESSION["CART"]->init();
$PGM_SESSION["CART"]->calc_grandtotal();
clear_orderinfo();
$PGM_SESSION["wantsurl"] = "";

$t->pparse("out", "page");

include ($CFG["dirroot"] . "footer.php");

pgm_session_close($PGM_SESSION, $session_name);

/* *******************************************************************
 * FUNCTIONS
 ****************************************************************** */

/**
* This function saves the order info into the database 
*
* It stores an entry in the corresponding orders table, and then
* it stores the shopping cart content into the order_items table;
* finally, it prepares the body of the e-mail message to be sent
* to the market seller.
* It returns the order id.
*
* @param array $order the order informations
* @param string $emailbody the body of the e-mail message
* @return string
*/
function create_order(&$order, &$emailbody) {
	global $_SERVER;
	global $PGM_SESSION;
	global $adminday, $adminmonth, $ordersdb;

	/* build the custinfo string */
	$custinfo =
		  $ordersdb["Customer"] . " " . $order["customer"] . "\n"
		. $ordersdb["Phone"]    . " " . $order["contact"] . "\n"
		. $ordersdb["Address"]  . "\n" . $order["address"] . " " . $order["number"] . "\n"
		. " " . $order["zip_code"] . "\n " . $order["city"] . "\n " . $order["country"] . "\n";

	/* save order information first */

//	$Date = $myday[date("w")] . date(" j ") . $mymonth[date("n")] . date(" Y H:i:s");
	$Dateusec = gettimeofday();
	$unixtime = $Dateusec["sec"];
	$year = date("Y");
	$month = date("n");
	$day = date("j");
	$weekday = date("w");
	$FromIP = $_SERVER["REMOTE_ADDR"];
	$Dateusec = gettimeofday();
	$orderid = $Dateusec["sec"] . sprintf("%06d", $Dateusec["usec"]) . "-" . $FromIP;

	$grandtotal = $PGM_SESSION["CART"]->get_grandtotal();
	$delivery = $PGM_SESSION["CART"]->get_delivery();
	
	$qid = new PGM_Sql();
	$qid->begin();

	$qid->query("
		INSERT INTO orders (
			 id
			,username
			,unixtime
			,year
			,month
			,day
			,weekday
			,fromip
			,custinfo
			,notes
			,amount
			,user_discount_id
			,user_discount
			,delivery
			,state_id
		) VALUES (
			 '$orderid'
			,'" . $PGM_SESSION["user"]["username"] . "'
			,'$unixtime'
			,'$year'
			,'$month'
			,'$day'
			,'$weekday'
			,'$FromIP'
			,'$custinfo'
			,'" . $order["data1"] . "\n" . $order["data2"] . "\n" . $order["comments"] . "'
			,'$grandtotal'
			,'" . $PGM_SESSION["user"]["user_discount_id"] . "'
			,'" . $PGM_SESSION["user"]["user_discount"] . "'
			,'$delivery'
			,'1'
		)
	");

	$order_comments = stripslashes ($order["comments"]);
	$emailbody .= "\n" . $ordersdb["Cash_On_Delivery"] . "\n"
		. "\n" . $ordersdb["Order"] . " " . $orderid
		. "\n" . $ordersdb["Username"] . ": " . $PGM_SESSION["user"]["username"]
		. "\n" . $ordersdb["Date"] . ": " . $adminday[$weekday] . " " . $day . " " . $adminmonth[$month] . " " . $year
		. "\n" . $ordersdb["Comments"] . ":\n" . $order_comments
		. "\n\n" . $ordersdb["TOTAL"] . ": " . formatted_price_text($PGM_SESSION["CART"]->get_grandtotal()) . "\n";

	/* now add the shopping cart items into the order_items table */
	$products_list = array();
	$products_list = $PGM_SESSION["CART"]->get_items_array();
	for ($cnt=0; $cnt<count($products_list); $cnt++) {
		$color = $products_list[$cnt]["color_name"];
		if ($products_list[$cnt]["color_lname"] != "") {
			$color .= " (" . $products_list[$cnt]["color_lname"] . ")";
		}

		$product_id = $products_list[$cnt]["id"];
		$name = addslashes($products_list[$cnt]["name"]);
		$price = $products_list[$cnt]["price"];
		$discount = $products_list[$cnt]["discount"];
		$discqty = $products_list[$cnt]["discqty"];
		$iva = $products_list[$cnt]["iva"];
		$weight = $products_list[$cnt]["weight"];
		$qty = $products_list[$cnt]["qty"];
		$variant = $products_list[$cnt]["variant"];
		$qid->query("
			INSERT INTO order_items (
				 order_id
				,product_id
				,name
				,price
				,discount
				,discqty
				,iva
				,weight
				,qty
				,variant
			) VALUES (
				 '$orderid'
				,'$product_id'
				,'$name'
				,'$price'
				,'$discount'
				,'$discqty'
				,'$iva'
				,'$weight'
				,'$qty'
				,'$variant'
			)
		");

		$emailbody .= "\n" . $ordersdb["Product"] . " " . $products_list[$cnt]["id"] . " - " . stripslashes($products_list[$cnt]["name"]);
		$emailbody .= "\n" . $ordersdb["Unit_Price"] . ": " . formatted_price_text($products_list[$cnt]["price"])
			. "\n" . $ordersdb["Number_of_items"] . ": " . $products_list[$cnt]["qty"] . "\n";
	}

	$qid->commit();

	$foobar = $PGM_SESSION["CART"]->get_delivery();
	if ($foobar != 0) {
		$emailbody .= "\n" . $ordersdb["Delivery"] . ": " . formatted_price_text($foobar);
	}

	return $orderid;
}

?>
