<?php
// (C) 2005 Matteo Lucarelli
// (C) 2000-2002 Marco Pratesi <marco@pgmarket.net>
// (C) 2000 Ying Zhang (ying@zippydesign.com)

include ("../config.inc.php");
include ("../common.inc.php");

$id = nvl($_GET["id"], 1);
if (!isset($_GET["page_number"])) {
	$page_number = 1;
} else {
	$page_number = max(1, abs(intval($_GET["page_number"])));
}

$DOC_TITLE = "Shopping_Catalog";
$PGM_SESSION["goback"]["request_uri"] = stripsid(me() . "?" . $_SERVER["QUERY_STRING"]);
include ($CFG["dirroot"] . "header.php");

build_category_path($id, $category_path);

// get the name and description of current cathegory
$qid_cc = new PGM_Sql();
$qid_cc->pgm_lang_join_query(
	$CFG["base_lang"],
	array("categories c", "categories_i18n l"),
	array(array("c.id", "l.category_id", 1, $PGM_SESSION["lang"])),
	array(array("l.name AS lname",  "l.description AS ldescription")),
	"c.id, c.name, c.special_level, c.description ,c.imagetype, c.imagewidth, c.imageheight, c.thumbwidth, c.thumbheight, c.thumbtype",
	"",
	"c.id = '$id'",
	"",
	""
);

$qid_cc->next_record();

// get the name and description of all the sub-categories under this one 
$qid_c = new PGM_Sql();
$qid_c->pgm_lang_join_query(
	$CFG["base_lang"],
	array("categories c", "categories_i18n l"),
	array(array("c.id", "l.category_id", 1, $PGM_SESSION["lang"])),
	array(array("l.name AS lname",  "l.description AS ldescription")),
	"c.id, c.name, c.special_level, c.description",
	"",
	"parent_id = '$id' AND id > 1",
	"special_level, name",
	array()
);
// get all the products under this category 
$qid_p = new PGM_Sql();
$qid_p->query("
	SELECT COUNT(p.id) AS cnt
	FROM products p, products_categories pc
	WHERE p.id = pc.product_id AND pc.category_id = '$id'
");
$qid_p->next_record();
include ($CFG["libdir"] . "pgm_pager.inc.php");
if (!isset($_GET["page_number"])) {
	$page_number = 1;
} else {
	$page_number = max(1, abs(intval($_GET["page_number"])));
}
$result = pgm_pager($ME, $qid_p->f("cnt"), $CFG["products_per_catalog_page"], $page_number);
$limit = $result["last"] - $result["first"] + 1;
$qid_p->pgm_lang_join_query(
	$CFG["base_lang"],
	array("products p", "products_i18n l"),
	array(array("p.id", "l.product_id", 1, $PGM_SESSION["lang"])),
	array(array("l.name AS lname",  "l.description AS ldescription")),
	"p.id, p.code, p.name AS name, p.price, p.discount, p.discqty, p.weight, p.special_flag, p.special_level, p.description, p.thumbtype, p.thumbwidth, p.thumbheight, pc.category_id, i.iva",
	"products_categories pc, iva i",
	"p.id = pc.product_id AND p.iva_id = i.id AND pc.category_id = '$id'",
	"special_level ASC",
	array($result["first"], $limit)
);

$t = new Template();
$t->set_file("page", "templates/index.ihtml");
include ($CFG["localelangdir"] . "global-common.inc.php");
include ($CFG["localelangdir"] . "global-shopping.inc.php");
include ($CFG["localelangdir"] . "global-admin.inc.php");
$t->set_var(array(
	"wwwroot"	=> $CFG["wwwroot"],
	"productswww"	=> $CFG["productswww"],
	"id"		=> $id,
	"category_path"	=> $category_path,
	"QSID"		=> (SID == "") ? "" : "?" . SID
));

// category thumb
$t->set_block("page", "catthumb", "catthumb_blck");
$t->set_var("catthumb_blck", "");
if ($CFG["images_on_file_system"] && file_exists($CFG["productsdir"] . "cat" . $qid_cc->f("id") . ".thumb." . $qid_cc->f("thumbtype"))) {
	$t->set_var(array(
		"catthumbwidth"	=> $qid_cc->f("thumbwidth"),
		"catthumbheight"=> $qid_cc->f("thumbheight")));
	if (has_priv("admin")) {
		$t->set_var("catthumbsrc", $CFG["wwwroot"] . "admin/getimage.php?image=" . "cat" . $qid_cc->f("id") . ".thumb." . $qid_cc->f("thumbtype") . "&amp;type=" . $qid_cc->f("thumbtype"));
	} else {
		$t->set_var("catthumbsrc", $CFG["productswww"] . "cat" . $qid_cc->f("id") . ".thumb." . $qid_cc->f("thumbtype"));
	}
	$t->parse("catthumb_blck", "catthumb", true);
} else if (!$CFG["images_on_file_system"] && $qid_cc->f("imagetype") != "") {
	$t->set_var(array(
		"catthumbwidth"	=> $qid_cc->f("thumbwidth"),
		"catthumbheight"=> $qid_cc->f("thumbheight")));
	if (has_priv("admin")) {
		$t->set_var("catthumbsrc", $CFG["wwwroot"] . "admin/dbgetimage.php?type=thumb&from=categories&id=" . $qid_cc->f("id"));
	} else {
		$t->set_var("catthumbsrc", $CFG["wwwroot"] . "dbgetimage.php?type=thumb&from=categories&id=" . $qid_cc->f("id"));
	}
	$t->parse("catthumb_blck", "catthumb", true);
}
$t->set_var("category_description", ($qid_cc->f("ldescription") != "") ? $qid_cc->f("ldescription") : $qid_cc->f("description"));

// subcategories list
$t->set_block("page", "subcategories", "subcategories_blck");
$t->set_var("subcategories_blck", "");
if ($CFG["subcategories_used"]){
	$t->set_block("subcategories", "no_sub_categories", "no_sub_categories_blck");
	$t->set_var("no_sub_categories_blck", "");
	$t->set_block("subcategories", "category_row", "category_rows");
	$t->set_var("category_rows", "");
	if ($qid_c->num_rows() == 0) {
		$t->parse("no_sub_categories_blck", "no_sub_categories", true);
	} else {
		while ($qid_c->next_record()) {
			$foobar = ($qid_c->f("lname") != "") ? $qid_c->f("lname") : $qid_c->f("name");
			if (has_priv("admin")) {
				$t->set_var(array(
					"c_special_level"	=> $qid_c->f("special_level") . " - ",
					"category_id"		=> $qid_c->f("id"),
					"cname"			=> ov($foobar)
				));
			} else {
				$t->set_var(array(
					"c_special_level"	=> "",
					"category_id"		=> $qid_c->f("id"),
					"cname"			=> ov($foobar)
				));
			}
			$t->parse("category_rows", "category_row", true);
		}
	}
	$t->parse("subcategories_blck", "subcategories", true);

}

// the tree menu
$t->set_block("page", "treemenu", "treemenu_blck");
$t->set_var("treemenu_blck", "");
if ($CFG["treemenu_used"]){
	include ($CFG["libdir"] . $CFG["dbms"] . "_treemenu_queries.inc.php");
	include_once ($CFG["libdir"] . "phplayersmenu/layersmenu.inc.php");
	include ($CFG["libdir"] . "phplayersmenu/layersmenu-noscript.inc.php");
	build_catbrowser($categories, 0);
	if ($categories != "") {
		$tree_mid = new XLayersMenu();
		$tree_mid->set_separator("^");
		$tree_mid->set_dirroot($CFG["dirroot"]);
		$tree_mid->set_libdir($CFG["libdir"] . "phplayersmenu/");
		$tree_mid->set_libwww($CFG["libwww"] . "phplayersmenu/");
		$tree_mid->set_imgdir($CFG["imagesdir"]);
		$tree_mid->set_imgwww($CFG["imageswww"]);
		$tree_mid->set_menu_structure_string($categories);
		$tree_mid->parse_menu_structure("navigation");
		$tree_mid->new_tree_menu("navigation");
		$t->set_var("treemenu", $tree_mid->get_tree_menu("navigation"));
		$t->parse("treemenu_blck", "treemenu", true);
	} 
	//else $t->set_var("treemenu", "");
	//$t->parse("treemenu_blck", "treemenu", true);
}

// the admin commands for categories
$t->set_block("page", "admincat", "admincat_blck");
$t->set_var("admincat_blck", "");
if (has_priv("admin")) {
	$t->parse("admincat_blck", "admincat", true);
}

$t->set_block("page", "products", "products_blck");
$t->set_var("products_blck", "");

// category image (is shown if there are no products)
$t->set_block("page", "no_products", "no_products_blck");
$t->set_var("no_products_blck", "");
if ($qid_p->num_rows() == 0) {
	if ($CFG["images_on_file_system"] && file_exists($CFG["productsdir"] . "cat" . $qid_cc->f("id") . "." . $qid_cc->f("imagetype"))) {
		$t->set_var(array(
			"catimagewidth"	=> $qid_cc->f("imagewidth"),
			"catimageheight"=> $qid_cc->f("imageheight")));
		if (has_priv("admin")) {
			$t->set_var("catimagesrc", $CFG["wwwroot"] . "admin/getimage.php?image=" . "cat" . $qid_cc->f("id") . "." . $qid_cc->f("imagetype") . "&amp;type=" . $qid_cc->f("imagetype"));
		} else {
			$t->set_var("catimagesrc", $CFG["productswww"] . "cat" . $qid_cc->f("id") . "." . $qid_cc->f("imagetype"));
		}
		$t->parse("no_products_blck", "no_products", true);
	} else if (!$CFG["images_on_file_system"] && $qid_cc->f("imagetype") != "") {
		$t->set_var(array(
			"catimagewidth"	=> $qid_cc->f("imagewidth"),
			"catimageheight"=> $qid_cc->f("imageheight")));
		if (has_priv("admin")) {
			$t->set_var("catimagesrc", $CFG["wwwroot"] . "admin/dbgetimage.php?type=image&from=categories&id=" . $qid_cc->f("id"));
		} else {
			$t->set_var("catimagesrc", $CFG["wwwroot"] . "dbgetimage.php?type=image&from=categories&id=" . $qid_cc->f("id"));
		}
		$t->parse("no_products_blck", "no_products", true);
	}
} else {
	if ($qid_p->num_rows() != 0) {
	// Let us define blocks nested inside a product_row...
	// We indent the code to highlight the blocks' hierarchical nesting...
		$t->set_block("products", "pages_links_bottom", "pages_links_bottom_blck");
		$t->set_var("pages_links_bottom_blck", "");
		if ($result["num_pages"] > 1) {
			$t->set_var("pages_links", $result["html"]);
			$t->parse("pages_links_bottom_blck", "pages_links_bottom", true);
		}
		$t->set_block("products", "product_row", "product_rows");
			$t->set_block("product_row", "brand_used", "brand_used_blck");
			$t->set_block("product_row", "adminprod", "adminprod_blck");
				$t->set_block("adminprod", "special_flag", "special_flag_blck");
			$t->set_block("product_row", "prodthumb", "prodthumb_blck");
			$t->set_block("product_row", "price_used", "price_used_blck");
				$t->set_block("price_used", "user_discount_used", "user_discount_used_blck");
				$t->set_block("price_used", "discount_block", "discount_block_blck");
					$t->set_block("discount_block", "discqty_block", "discqty_block_blck");
			$t->set_block("product_row", "is_logged_user", "is_logged_user_blck");		

			
	// ... end of the blocks :)
		$t->set_var("product_rows", "");	// Now let us reset the product rows container...
		while ($qid_p->next_record()) {
	// Now let us reset the blocks contents...
	// We indent the code to highlight the blocks' hierarchical nesting...
			$t->set_var("brand_used_blck", "");
			$t->set_var("adminprod_blck", "");
				$t->set_var("special_flag_blck", "");
			$t->set_var("prodthumb_blck", "");
			$t->set_var("user_discount_used_blck", "");
			$t->set_var("discount_block_blck", "");
				$t->set_var("discqty_block_blck", "");
			$t->set_var("is_logged_user_blck", "");
			$t->set_var("price_used_blck", "");
			
	// ... now we have reset all nested blocks :)
			$t->set_var(array(
				"id"		=> $id,
				"product_id"	=> $qid_p->f("id"),
				"product_code"	=> $qid_p->f("code"),
				"pname"		=> ($qid_p->f("lname") != "") ? ov($qid_p->f("lname")) : ov($qid_p->f("name")),
				"description"	=> ($qid_p->f("ldescription") != "") ? ovwbr($qid_p->f("ldescription")) : ovwbr($qid_p->f("description")),
				"productitemcount"	=> $PGM_SESSION["CART"]->get_product_qty($qid_p->f("id"))
			));
			if (has_priv("admin")) {
				$t->set_var("p_special_level", $qid_p->f("special_level"));
				if ($qid_p->f("special_flag")) {
					$t->parse("special_flag_blck", "special_flag", true);
				}
				$t->parse("adminprod_blck", "adminprod", true);
			}
			if ($CFG["images_on_file_system"] && file_exists($CFG["productsdir"] . $qid_p->f("id") . ".thumb." . $qid_p->f("thumbtype"))) {
				$t->set_var(array(
					"thumbwidth"	=> $qid_p->f("thumbwidth"),
					"thumbheight"	=> $qid_p->f("thumbheight")
				));
				if (has_priv("admin")) {
					$t->set_var("thumbsrc", $CFG["wwwroot"] . "admin/getimage.php?image=" . $qid_p->f("id") . ".thumb." . $qid_p->f("thumbtype") . "&amp;type=" . $qid_p->f("thumbtype"));
				} else {
					$t->set_var("thumbsrc", $CFG["productswww"] . $qid_p->f("id") . ".thumb." . $qid_p->f("thumbtype"));
				}
				$t->parse("prodthumb_blck", "prodthumb", true);
			} else if (!$CFG["images_on_file_system"] && $qid_p->f("thumbtype") != "") {
				$t->set_var(array(
					"thumbwidth"	=> $qid_p->f("thumbwidth"),
					"thumbheight"	=> $qid_p->f("thumbheight")
				));
				if (has_priv("admin")) {
					$t->set_var("thumbsrc", $CFG["wwwroot"] . "admin/dbgetimage.php?type=thumb&from=products&id=" . $qid_p->f("id"));
				} else {
					$t->set_var("thumbsrc", $CFG["wwwroot"] . "dbgetimage.php?type=thumb&from=products&id=" . $qid_p->f("id"));
				}
				$t->parse("prodthumb_blck", "prodthumb", true);
			}
			if ($CFG["price_used"]) {
				$t->set_var("fprice",formatted_price($qid_p->f("price")));
				$t->parse("price_used_blck", "price_used", true);
			}
			if ($CFG["user_discount_used"] && is_logged_in() && $PGM_SESSION["user"]["user_discount"] > 0) {
				$t->set_var(array(
					"user_discount"		=> $PGM_SESSION["user"]["user_discount"],
					"discounted_price"	=> formatted_price((1.0-$PGM_SESSION["user"]["user_discount"]/100.0)*$qid_p->f("price"))
				));
				$t->parse("user_discount_used_blck", "user_discount_used", true);
			}
			if ($qid_p->f("discount") > 0) {
				$t->set_var("discount", $qid_p->f("discount"));
				if ($qid_p->f("discqty") > 1) {
					$t->set_var("discqty", $qid_p->f("discqty"));
					$t->parse("discqty_block_blck", "discqty_block", true);
				}
				$t->parse("discount_block_blck", "discount_block", true);
			}
			if (is_logged_in() && !has_priv("admin")) $t->parse("is_logged_user_blck", "is_logged_user", true);

			$t->parse("product_rows", "product_row", true);
		}
		$t->parse("products_blck", "products", true);
	}
}

$t->pparse("out", "page");

include ($CFG["dirroot"] . "footer.php");

pgm_session_close($PGM_SESSION, $session_name);

?>
